import { Maybe } from './maybe.js';
import { None, Some } from './utilities.js';
/**
 * Converts string, null, or undefined values into a Maybe<string>. Throws an error for defined, non-string values.
 * @param value
 * @returns Maybe.some when value is defined and non-empty, Maybe.none otherwise.
 */
export declare function emptyStringAsNone(value: Some<string> | None): Maybe<string>;
/**
 * Converts string, null, or undefined values into a Maybe<string>. Throws an error for defined, non-string values.
 * @param value
 * @returns Maybe.some when value is defined, non-empty, and non-whitespace, Maybe.none otherwise.
 */
export declare function emptyOrWhiteSpaceStringAsNone(value: Some<string> | None): Maybe<string>;
/**
 * Converts number, null, or undefined values into a Maybe<number>. Throws an error for defined, non-number values.
 * @param value
 * @returns Maybe.some when value is defined and non-zero, Maybe.none otherwise.
 */
export declare function zeroAsNone(value: Some<number> | None): Maybe<number>;
